/* $Header: /cvsroot/dhcp-agent/dhcp-agent/dhcp-exception.h,v 1.1 2002/06/22 18:11:25 actmodern Exp $
 *
 * Copyright 2002 Thamer Alharbash
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#define MAX_EXCEPTION_STACK 64

typedef struct {
    stringbuffer *exception_message[MAX_EXCEPTION_STACK];
    const char *module_name[MAX_EXCEPTION_STACK];
    const char *function_name[MAX_EXCEPTION_STACK];
    int cur_index;
}  exception_t;

extern void init_exceptions(void);
extern void push_exception(const char *module_name, const char *function_name,
                           char *fmt, ...);
extern stringbuffer *unroll_exceptions(void);

#define THROW_EXCEPTION(module_name, func_name, msg, return_val) { (push_exception(module_name, func_name, msg); return return_val;) }
