/* $Header: /cvsroot/dhcp-agent/dhcp-agent/dhcp-files.h,v 1.4 2002/06/17 13:23:08 actmodern Exp $
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com> 
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Handles our variable files.
 *
 */

#ifndef DHCP_FILE
#define DHCP_FILE

extern FILE *file_open_or_create_safe(const char *filename, char *mode);
extern FILE *file_create_and_truncate_safe(const char *filename, char *mode);

extern int file_exists(char *fname);
extern void move_file(char *fname, char *dest);
extern void delete_file(char *fname);
extern void make_file_public_read(char *fname);
extern void create_pid_file(char *name);
extern void delete_pid_file(char *name);
extern int get_pid_file(char *name, pid_t *pid);

#endif /* DHCP_FILE */
