/* $Header: /cvsroot/dhcp-agent/dhcp-agent/dhcp-list.c,v 1.4 2002/06/17 13:23:08 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <dhcp-agent.h>
#include <dhcp-util.h>

list_t *add_to_list(list_t *head, void *datum)
{
  list_t *tmp;
  
  tmp = xmalloc(sizeof(list_t));
  tmp->data = datum;
  tmp->next = head;
  
  return tmp;
}

list_t *add_to_end_of_list(list_t *head, void *datum)
{
  list_t *tmp, *tmp2;

  tmp = xmalloc(sizeof(list_t));
  tmp->data = datum;
  tmp->next = NULL;
  
  if(head == NULL)  {
	return tmp;
  } else {
	for(tmp2 = head;tmp2->next;tmp2 = tmp2->next);
        tmp2->next = tmp;
      
      if(head == NULL)
	return tmp;
      else
          return head;
  }
}

list_t *remove_from_list(list_t *head, void *datum)
{
  list_t *tmp, *tmp2;
  
  if(head->data == datum)  {
	tmp = head->next;
	xfree(head);
	return tmp;
  } else {
	
	for(tmp = head;tmp->next;tmp = tmp->next)  {
	  
	  if(tmp->next->data == datum)  {
		tmp2 = tmp->next;
		tmp->next = tmp->next->next;
		xfree(tmp2);
		return head;
	  }
	}
  }
  
  return NULL; /* this should never happen. */
  
}

/* for convert array. */

void purge_list_internal(void *head)
{
    purge_list((list_t *)head, NULL);
}

void purge_list(list_t *head, void (*purge_func)(void *d))
{
    list_t *tmp;
    
    while(head != NULL)  {
        tmp = head;
        head = head->next;
        
        if(purge_func)
            purge_func(tmp->data);
        else
            xfree(tmp->data);

            xfree(tmp);
    }
    
    return;
}

list_t *join_lists(list_t *first_list, list_t *second_list)
{
    list_t *ptr;
    
    if(first_list == NULL)
        return second_list;
    
    if(second_list == NULL)
        return first_list;
    
    for(ptr = first_list;ptr->next;ptr = ptr->next);
    
    ptr->next = second_list;
    
    return first_list;
}
