/* $Header: /cvsroot/dhcp-agent/dhcp-agent/dhcp-parser.h,v 1.2 2002/06/17 13:23:08 actmodern Exp $
 *
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com> 
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Parser for varfiles.
 *
 */

#ifndef DHCP_PARSER_H
#define DHCP_PARSER_H

#define PARSER_TOKEN_ERROR             0
#define PARSER_TOKEN_NEWLINE           1
#define PARSER_TOKEN_EOF               2
#define PARSER_TOKEN_QUOTED_STRING     3
#define PARSER_TOKEN_STRING            4
#define PARSER_TOKEN_ASSIGNMENT        5

#define PARSER_ATOM_ERROR              0
#define PARSER_ATOM_STRING             1
#define PARSER_ATOM_ASSIGNMENT         2
#define PARSER_ATOM_END_OF_STATEMENT   3
#define PARSER_ATOM_EOF                4

typedef uint8_t token_t;
typedef uint8_t atom_t;

typedef struct {
    FILE *fp;
    int line_no;
    stringbuffer *data_buff;
} parser_t;

extern void destroy_parser(parser_t *parser);
extern parser_t *create_parser(const char *filename);
extern atom_t get_next_atom(parser_t *input);
extern const char *parser_get_data(parser_t *input);
extern int parser_get_line_no(parser_t *parser);

#endif /* DHCP_PARSER_H */
