/* $Header: /cvsroot/dhcp-agent/dhcp-agent/dhcp-rtt.h,v 1.2 2002/06/17 13:23:08 actmodern Exp $
 *
 * Copyright 2002 Thamer Alharbash
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#ifndef DHCP_RTT_H
#define DHCP_RTT_H

/* timeout as per rfc2131 */

#define MILLISECOND_TIMEOUT      4000
#define MILLISECOND_RAND_TIMEOUT 1000
#define MAX_SECS_WAIT 64           /* as mentioned in rfc2131, 
                                    * 64 seconds is the upper limit of waiting time. */

/* Utility macros. */

#define SECS_TO_MSECS(x)      (x * 1000)
#define MSECS_TO_SECS(x)      (x/1000)
#define MSECS_TO_MSECS_REM(x) (x%1000)

/* rtt struct. */

typedef struct rtt {
    struct timeval timeout;
} rtt_t;

/* prototypes. */

extern rtt_t *rtt_create(void);
extern struct timeval rtt_get_timeout(rtt_t *rtt);
extern void rtt_timeout(rtt_t *rtt);
extern int rtt_can_retry(rtt_t *rtt);
extern void rtt_destroy(rtt_t *rtt);

#endif /* DHCP_RTT_H */
