/* $Header: /cvsroot/dhcp-agent/dhcp-agent/dhcp-stringbuffer.h,v 1.5 2002/06/22 18:11:25 actmodern Exp $
 *
 * Copyright 2002 Thamer Alharbash
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#ifndef DHCP_STRINGBUFFER_H
#define DHCP_STRINGBUFFER_H

/* string buffer object. */
typedef struct {
  int len;
  int capacity;
  char *buf;
} stringbuffer;

extern stringbuffer *create_stringbuffer(void);
extern void destroy_stringbuffer(stringbuffer *sb);
extern void stringbuffer_append(stringbuffer *sb, const char *s);
extern stringbuffer *stringbuffer_trim_whitespace(stringbuffer *sb);
extern char *stringbuffer_get_last_occurance(stringbuffer *sb, char c);
extern void stringbuffer_trim_newline(stringbuffer *sb);
extern const char *stringbuffer_getstring(stringbuffer *sb);
extern void stringbuffer_aprintf(stringbuffer *sb, char *fmt, ...);
extern void stringbuffer_aprintf_align(stringbuffer *sb, int begin, int end, char *fmt, ...);
extern void stringbuffer_avprintf(stringbuffer *sb, char *fmt, va_list ap);
extern void stringbuffer_append_c(stringbuffer *sb, char c);
extern void stringbuffer_clear(stringbuffer *sb);
extern char *stringbuffer_getnextline(stringbuffer *sb, char *c);
extern void stringbuffer_marknewlines(stringbuffer *sb);
extern void stringbuffer_set(stringbuffer *dest, const char *s);

#endif /* DHCP_STRINGBUFFER_H */
