/* $Header: /cvsroot/dhcp-agent/dhcp-agent/dhcp-sysconf.h,v 1.2 2002/06/17 13:23:08 actmodern Exp $
 *
 * Copyright 2002 Thamer Alharbash
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#ifndef SYSCONF_H
#define SYSCONF_H

/* Sysconf handler. */

typedef struct {
    int (*sysconf_handler)(void *value, dhcp_client_control_t *dc);
} sysconf_handler;


/* System configuration routines. */

extern int sysconf_routers(void *value, dhcp_client_control_t *dc);
extern int sysconf_domain_name_servers(void *value, dhcp_client_control_t *dc);
extern int sysconf_domain_name(void *value, dhcp_client_control_t *dc);
extern void do_sysconf(list_t *options, dhcp_client_control_t *dc);

#endif /* SYSCONF_H */

